library angular2.src.core.pipes.pipe_binding;

import "package:angular2/src/core/facade/lang.dart" show Type;
import "package:angular2/src/core/di/binding.dart"
    show ResolvedFactory, resolveBinding;
import "package:angular2/src/core/di.dart" show Key, ResolvedBinding, Binding;
import "../metadata/directives.dart" show PipeMetadata;

class PipeBinding extends ResolvedBinding {
  String name;
  bool pure;
  PipeBinding(this.name, this.pure, Key key,
      List<ResolvedFactory> resolvedFactories, bool multiBinding)
      : super(key, resolvedFactories, multiBinding) {
    /* super call moved to initializer */;
  }
  static PipeBinding createFromType(Type type, PipeMetadata metadata) {
    var binding = new Binding(type, toClass: type);
    var rb = resolveBinding(binding);
    return new PipeBinding(metadata.name, metadata.pure, rb.key,
        rb.resolvedFactories, rb.multiBinding);
  }
}
